import pygame, sys, os, time
#from olpcgames import *
from pygame.locals import *

def load_image(name, colorkey=None):
        """loads an image into memory"""
        fullname = os.path.join('data', name)
        try:
            image = pygame.image.load(fullname)
        except pygame.error, message:
            print 'Cannot load image:', fullname
            raise SystemExit, message
        image = image.convert_alpha()
        if colorkey is not None:
            if colorkey is -1:
                colorkey = image.get_at((0,0))
            image.set_colorkey(colorkey, RLEACCEL)
        return image, image.get_rect()

# HorizontalWalker is a blight on existence, a mind-raveling vomitorium of logic, a black goat with a thousand young.
# It is also the base class that is extended to create zombies, bunnies, and other things that need to:
#       1) Start on either the right side or the left side
#       2) Walk the other way until they hit a limit (given in the constructor)
#       3) Wait, do a weirdly-timed animation, and turn around
#       4) Walk back until they hit the other limit (also given in the constructor) and then kill themselves
# HorizontalWalker has an update method that increments an internal timer and decides, based on that and an arcane
# combination of framesPerSecond and another var called seconds, whether to switch to the next frame in its existing
# cycle.  (Cycles are set in the child class.)  The update method also moves it horizontally.
#
# I wrote the code to decide whether to switch frames at a given time and, I'm warning you, I DO NOT UNDERSTAND WHY IT WORKS.
# I am considering scrapping this whole thing for level 2.  But I probably won't.

class HorizontalWalker(pygame.sprite.Sprite):

        # The world's biggest constructor--always the mark of a cleanly modulated class.
        # homeSide helps decide when to disappear based on hitting limits (acceptable values are "right" and "left").
        # startX and startY are obvious.  dirX mimics homeSide but helps decide which direction it should start walking in
        # when initialized.  pixelsPerFrame sets the horizontal movement speed.  waitTime is the number of clock ticks (or frames)
        # to wait when the sprite hits its non-lethal limit side; it's very hacky and will probably do weird things if it's not 48.
        
        def __init__(self, homeSide, startX, startY, dirX, leftLimit, rightLimit, framesPerSecond, xPixelsPerFrame, yPixelsPerFrame, waitTime):
                
                pygame.sprite.Sprite.__init__(self)

                # loadFrames is just an abstract function here; in the child class it will be a big giant list of frame images.
                self.loadFrames()

                # init vars.
                self.framesPerSecond = framesPerSecond
                self.leftLimit = leftLimit
                self.rightLimit = rightLimit
                self.homeSide = homeSide
                self.xPixelsPerFrame = xPixelsPerFrame
                self.yPixelsPerFrame = yPixelsPerFrame
                self.waitTime = waitTime

                self.counter = 0
                self.waitCounter = 0
                self.arrived = False
                
                # The number of seconds to take for a single animation cycle.
                # Usually only changed for the win animation, etc.
                self.seconds = 1

                # initial position and direction
                self.setDir(dirX, True)
                self.rect.topleft = (startX, startY)

        def loadFrames(self):
                pass

        def playFrustrated(self):
                pass

        # setDir is what was killing me when we had to get Bimal over here.  It should be a genuine set
        # function, but instead it has just enough functionality to be dangerous.
        #
        # First it sets the dirX variable.  That's simple enough.
        # Then it picks out animation cycles based on the dirX, which--brilliantly!--is not
        # confined to just "left" and "right."  It can also be "leftWin" and "rightWin," which
        # prevent the sprite from moving but allow it to continue animating, facing a given direction.
        # There used to be a direction called "stop."  Happily, there isn't anymore.
        #
        # The final thing setDir does is figure out ticksPerFrame, which is used to time the animation
        # against the framerate (eg if we're running at 12 fps but have only 6 frames in a given cycle,
        # ticksPerFrame should be 2).  It gets weird because the seconds variable comes into play, and
        # thus can increase ticksPerFrame for long cycles that are more than one second long, etc.
        #
        # I hate ticksPerFrame.

        def setDir(self, dirX, initial = False):

                self.dirX = dirX

                # Oh, I forgot about initial--obviously, if you're creating this sprite for the first time,
                # you pass initial as True and it creates a standing-still picture as the first frame,
                # plus actually creates the rectangle for the sprite based on it.

                # When facing left or right, you get a walk cycle and a sad cycle, and ticksPerFrame is derived from the
                # length of the walk cycle.

                if (dirX == "left"):
                        self.walkCycle = self.leftWalkCycle
                        self.sadCycle = self.leftSadCycle
                        if initial == True:
                                self.still, self.rect = load_image(self.leftStandLocation, -1)
                                self.image = self.still
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.walkCycle)

                elif (dirX == "right"):
                        self.walkCycle = self.rightWalkCycle
                        self.sadCycle = self.rightSadCycle
                        if initial == True:
                                self.still, self.rect = load_image(self.rightStandLocation, -1)
                                self.image = self.still
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.walkCycle)

                # When facing left or right AND WINNING, you only get a win cycle, and ticksPerFrame is derived from that.
                # This also resets the counter so you don't keep walking into your winning buddy, and sets the arrived
                # variable to keep you from moving at all.
                # You'll notice that setting the direction to a win increases the seconds to 2.
                # This is really, really dumb.

                elif (dirX == "leftWin"):
                        self.winCycle = self.leftWinCycle
                        self.seconds = 2
                        self.counter = 0
                        self.arrived = True
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.winCycle)

                elif (dirX == "rightWin"):
                        self.winCycle = self.rightWinCycle
                        self.seconds = 2
                        self.counter = 0
                        self.arrived = True
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.winCycle)

        # setLimit resets the limit for a given side, in case you want your HorizontalWalker to go a shorter or
        # longer distance.  Not actually used yet--I made it to use in level 2 after the bridge is built.

        def setLimit(self, dirX, x):
                if dirX == "right":
                        self.rightLimit = x
                elif dirX == "left":
                        self.leftLimit = x

        # update!  Over 100 lines of code, mostly duplicated in a conditional.  I hate myself.
        # update is a hook called by the group to which this sprite belongs, when the whole group is updated;
        # it increments the counter, switches the frame if necessary, moves the sprite if it's not frozen
        # and, if we're back at our starting limit, kills it.
            
        def update(self):

                # arrived is the internal variable that tells us whether we're sitting around at a limit
                # OR sitting around doing our win animation.  The counter only increments while it's false.
                
                if self.arrived == False:

                        # The counter gets incremented even when the frame doesn't change, which makes
                        # moving horizontally a little smoother.  It also helps determine whether we
                        # should be changing the frame.
                        
                        self.counter += 1

                        # Okay, here's how I think this works:  if we hit a multiple of ticksPerFrame
                        # on the counter, we switch to the next frame in the animation cycle.
                        # For instance, if ticksPerFrame is 3 and our counter just flipped over to 9,
                        # we'll move along...
                        
                        if self.counter % self.ticksPerFrame == 0:

                                # (... and if we've just reached the end of a second, reset the counter...)
                                
                                if self.counter == self.framesPerSecond:
                                        self.counter = 0

                                # ... and then figure out what our next step in the cycle is by doing an
                                # integer divide on the counter.  For instance, if (as above) we had a
                                # ticksPerFrame of 3 and a counter at 9, we'd move to the third element in our
                                # walk cycle.
                                        
                                self.walkFrame = self.counter // self.ticksPerFrame 
                                self.image = self.walkCycle[self.walkFrame]

                # Now we get into direction-specific stuff.
                            
                if self.dirX == "right":

                        # If we haven't hit our limit, move right by increasing the rectangle's left side ordinate.
                        if self.rect.right < self.rightLimit:
                                self.rect.left += self.xPixelsPerFrame
                                self.rect.top += self.yPixelsPerFrame

                        # If we have NOW hit our limit and we didn't hit it already, freeze
                        # the sprite and set arrived to true.  If this was where we came from
                        # to begin with, disappear the sprite and (invisibly) reverse it to head left again.
                        
                        if self.rect.right >= self.rightLimit and self.arrived == False:
                                self.image = self.still
                                self.arrived = True
                                self.counter = 0

                                # waitCounter here is used to figure out how long to sit around waiting for your
                                # friend to arrive.  This just makes sure to set a new one up when we hit our
                                # limit and stop.
                                
                                self.waitCounter = 0

                                # If we just got back to the right side and we're over our starting line, DIE!
                                # Actually "kill" just removes the sprite from all its groups.
                                # Since this update function will be called after the group is cleared but
                                # before it's redrawn, killing the sprite makes it invisible (but doesn't destroy
                                # the instance).  Adding it to the group again will resurrect it.
                                #
                                # This code also flips the sprite around again so it's looking the right way
                                # when it reappears.
                                
                                if self.homeSide == "right":
                                        self.kill()
                                        self.arrived = False
                                        self.setDir("left")

                        # If we're frozen, keep counting until we hit the waitTime (usually 48).
                        # When we hit that, reset the counter and flip us around to head back left, then
                        # set arrived to false.
                        
                        if self.arrived == True:

                                # As long as the waitCounter hasn't reached our max waitTime,
                                # keep incrementing it; as soon as we do hit the max waitTime,
                                # play the frustrated sound for this sprite (defined in the child
                                # class).

                                if self.waitCounter < self.waitTime:
                                        self.waitCounter += 1
                                        if self.waitCounter == self.waitTime:
                                                self.playFrustrated()

                                # If we've hit our allotted waitTime, stop incrementing waitCounter
                                # and start playing animation.

                                # I'm sorry, I just can't comment this next part.  It hurts my brain too much.
                                # Somehow, it puts together a 2-second animation cycle from only 6 frames
                                # by pausing for a long time on the fourth frame.  This code came to me
                                # in a fit of desperation and I don't know how it works anymore.
                            
                                elif self.waitCounter == self.waitTime:
                                        self.counter += 1
                                        if self.counter % self.ticksPerFrame == 0:
                                                
                                                if self.counter == 2 * self.framesPerSecond:
                                                        self.arrived = False
                                                        self.counter = 0
                                                        
                                                self.sadFrame = self.counter // self.ticksPerFrame
                                                if self.sadFrame > 4 and self.counter < (self.framesPerSecond * 2) - (self.ticksPerFrame * 2):
                                                        self.sadFrame = 4

                                                elif self.sadFrame > 4:
                                                        self.sadFrame = self.counter // (self.ticksPerFrame * 2)
                                                        
                                                self.image = self.sadCycle[self.sadFrame]

                                # Once we've decided to stop waiting, reset our waitCounter and turn around to head back left.
                                # self.arrived gets set to False in the previous block, so that this triggers only when it's
                                # done.  Probably.s
                            
                                if self.arrived == False:
                                        self.waitCounter = 0
                                        self.setDir("left")
                            
                elif self.dirX == "left":

                        # This really is exactly the same as the above block, just reversed.
                        # Also we'll be decremengint the rectangle's left ordinate value instead of increasing
                        # it, since we're on the right side of the Cartesian x-axis here.
                        
                        if self.rect.left > self.leftLimit:
                                self.rect.left -= self.xPixelsPerFrame
                                self.rect.top -= self.yPixelsPerFrame
                                
                        if self.rect.left <= self.leftLimit and self.arrived == False:
                                self.image = self.still
                                self.arrived = True
                                self.counter = 0
                                self.waitCounter = 0

                                if self.homeSide == "left":
                                        self.kill()
                                        self.arrived = False
                                        self.setDir("right")
                                        
                        if self.arrived == True:

                                if self.waitCounter < self.waitTime:
                                        self.waitCounter += 1
                                        if self.waitCounter == self.waitTime:
                                                self.playFrustrated()
                            
                                elif self.waitCounter == self.waitTime:
                                        self.counter += 1
                                        if self.counter % self.ticksPerFrame == 0:
                                                
                                                if self.counter == 2 * self.framesPerSecond:
                                                        self.arrived = False
                                                        self.counter = 0
                                                        
                                                self.sadFrame = self.counter // self.ticksPerFrame
                                                if self.sadFrame > 4 and self.counter < (self.framesPerSecond * 2) - (self.ticksPerFrame * 2):
                                                        self.sadFrame = 4

                                                elif self.sadFrame > 4:
                                                        self.sadFrame = self.counter // (self.ticksPerFrame * 2)
                                                        
                                                self.image = self.sadCycle[self.sadFrame]
                            
                                if self.arrived == False:
                                        self.waitCounter = 0
                                        self.setDir("right")

                # The win directions make a little more sense.
                # They also maintain a counter, and cycle through the win cycle on it, again
                # based on framesPerSecond, seconds and ticksPerFrame.  I think there's a
                # math error in here somewhere but as long as it works I'm not going to try and fix it.

                elif self.dirX == "leftWin" or self.dirX == "rightWin":

                        self.counter += 1

                        if (self.counter < self.framesPerSecond * self.seconds):
                                if self.counter % self.ticksPerFrame == 0:

                                        self.winFrame = self.counter // self.ticksPerFrame
                                        self.image = self.winCycle[self.winFrame]                                

                        else:
                                self.counter = 0

# A Zomzie carrying a cake.  Ding.

class ZomzieCake(HorizontalWalker):

        def loadFrames(self):
                
                self.rightStandLocation = 'zomzie/zom_rsadcake01.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake06.png')))
                self.leftStandLocation = 'zomzie/zom_lsadcake01.png'

                self.leftSadCycle = []
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake01.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake02.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake03.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake05.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake06.png')))
           
                self.rightWalkCycle = []     
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake06.png')))

                self.rightSadCycle = []
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake01.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake02.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake03.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake05.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake06.png')))

                self.leftWinCycle = []
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat07.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat08.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat09.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat10.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat11.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat12.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win06.png')))

        # Simple overridable function to load up an "eh" sound and play it when we start our sad-cycle above.

        def playFrustrated(self):
                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','zomzie_eh.ogg'))
                zomEatTrack.set_volume(0.8)
                zomEatTrack.play(0)

        # The win() function actually does very little--it just figures out which direction we're facing and
        # passes the real work off to setDir, up above.

        def win(self):
                if self.dirX == "right":
                        self.setDir("rightWin")
                elif self.dirX == "left":
                        self.setDir("leftWin")

# A bunny with milk.

class BunnyLou(HorizontalWalker):

        def loadFrames(self):
                
                self.rightStandLocation = 'bunnylou/bun_right.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop06.png')))                                         
                self.leftStandLocation = 'bunnylou/bun_left.png'

                self.leftSadCycle = []
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))
                
                self.rightWalkCycle = []
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop06.png')))

                self.rightSadCycle = []
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))

                self.rightWinCycle = []
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat07.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat08.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat09.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat10.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat11.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat12.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win06.png')))

        def playFrustrated(self):
                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','bunny_eh.ogg'))
                zomEatTrack.set_volume(0.8)
                zomEatTrack.play(0)

        def win(self):
                if self.dirX == "right":
                        self.setDir("rightWin")
                elif self.dirX == "left":
                        self.setDir("leftWin")

# PathWalker is like HorizontalWalker, but slightly less stupid.  In this case we're going to let
# the level change its direction and speed, so there are no more limit parameters.

class PathWalker(pygame.sprite.Sprite):

        # Constructor.
        
        def __init__(self, startX, startY, spriteDir, framesPerSecond, xPixelsPerFrame, yPixelsPerFrame, waitTime):
                
                pygame.sprite.Sprite.__init__(self)

                # loadFrames is just an abstract function here; in the child class it will be a big giant list of frame images.
                self.loadFrames()

                # init vars.
                self.framesPerSecond = framesPerSecond
                self.xPixelsPerFrame = xPixelsPerFrame
                self.yPixelsPerFrame = yPixelsPerFrame
                self.waitTime = waitTime

                self.counter = 0
                self.waitCounter = 0
                self.reverseAfterPout = True
                
                # The number of seconds to take for a single animation cycle.
                # Usually only changed for the win animation, etc.
                self.seconds = 1

                # initial position and direction
                self.setDir(spriteDir, True)
                self.rect.topleft = (startX, startY)

                # Whether or not we're in the pouting animation
                self.pouting = False

        def loadFrames(self):
                pass

        def playFrustrated(self):
                pass

        # Called when colliding with an object that wants the sprite to stop,
        # play the pout animation and sound, and reverse direction.

        def stopAndPout(self, reverse = True, seconds = 2):

                if self.pouting == False:

                        self.reverseAfterPout = reverse
                        self.counter = 0
                        self.pouting = True
                        self.playFrustrated()
                        self.seconds = seconds

        # Called when colliding with an object that wants us to disappear
        # and invisibly turn around, ready for a new walk cycle.

        def vanish(self, reverse = True):

                if self.alive() == True:

                        # self.kill()

                        self.counter = 0
                        self.pouting = False

                        # Fudge to make sure we're not colliding with that object again when we restart.
                        
                        """if (self.spriteDir == "right"):
                                self.rect.left -= self.xPixelsPerFrame
                                self.rect.top -= self.xPixelsPerFrame
                        else:
                                self.rect.left -= self.xPixelsPerFrame
                                self.rect.top -= self.xPixelsPerFrame"""
                        
                        if reverse == True:        
                                self.reverse()

        # Jump!

        def relocate(self, x, y):

                self.rect.topleft = (x, y)

        # Called by anything that wants us to turn around.

        def reverse(self):

                self.counter = 0
                self.seconds = 1
                self.xPixelsPerFrame *= -1
                if self.spriteDir == "right":
                        self.setDir("left")
                elif self.spriteDir == "left":
                        self.setDir("right")
                elif self.spriteDir == "up":
                        self.setDir("down")
                elif self.spriteDir == "right":
                        self.setDir("right")

        # Called by anything that's just changing our path direction.

        def deflect(self, newXPixelsPerFrame, newYPixelsPerFrame):

                self.xPixelsPerFrame = newXPixelsPerFrame
                self.yPixelsPerFrame = newYPixelsPerFrame

        def setDir(self, spriteDir, initial = False):

                self.spriteDir = spriteDir

                # When facing left or right, you get a walk cycle and a pout cycle, and ticksPerFrame is derived from the
                # length of the walk cycle.

                if (spriteDir == "left"):
                        self.walkCycle = self.leftWalkCycle
                        self.poutCycle = self.leftPoutCycle
                        if initial == True:
                                self.still, self.rect = load_image(self.leftStandLocation, -1)
                        self.image = self.still
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.walkCycle)
                        # self.ticksPerFrame = self.framesPerSecond / len(self.walkCycle)

                elif (spriteDir == "right"):
                        self.walkCycle = self.rightWalkCycle
                        self.poutCycle = self.rightPoutCycle
                        if initial == True:
                                self.still, self.rect = load_image(self.rightStandLocation, -1)
                        self.image = self.still
                        self.ticksPerFrame = self.framesPerSecond  * self.seconds / len(self.walkCycle)
                        # self.ticksPerFrame = self.framesPerSecond / len(self.walkCycle)

                # When facing left or right AND WINNING, you only get a win cycle, and ticksPerFrame is derived from that.
                # This also resets the counter so you don't keep walking into your winning buddy, and sets the arrived
                # variable to keep you from moving at all.
                # Setting the direction to a win NO LONGER CHANGES SECONDS--that's handled in the win function.
                # Which actually makes a little sense.

                elif (spriteDir == "leftWin"):
                        self.winCycle = self.leftWinCycle
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.winCycle)

                elif (spriteDir == "rightWin"):
                        self.winCycle = self.rightWinCycle
                        self.ticksPerFrame = self.framesPerSecond * self.seconds / len(self.winCycle)
            
        def update(self):

                # This is where we do the pouting animation.  At the end, we always set pouting to false,
                # then reverse directions.

                if self.pouting == True:

                        self.counter += 1

                        # As long as we haven't hit our frame limit, keep cycling through the pout.
                        
                        if (self.counter < self.framesPerSecond * self.seconds):

                                # If our counter is an even multiple of ticksPerFrame, pick a new frame image.

                                if self.counter % self.ticksPerFrame == 0:

                                        self.poutFrame = self.counter // self.ticksPerFrame
                                        self.image = self.poutCycle[self.poutFrame]

                        # If our counter has hit the limit of frames we want to play for
                        # this animation (probably 2), reset it to 0 and do the finishing stuff.

                        else:
                                self.pouting = False
                                self.seconds = 1

                                if self.reverseAfterPout == True:
                                        self.reverse()

                elif self.spriteDir == "left" or self.spriteDir == "right":

                        self.counter += 1
                        
                        self.rect.top += self.yPixelsPerFrame
                        self.rect.left += self.xPixelsPerFrame

                        # If our counter has hit the limit of frames we want to play for
                        # this animation (probably 2), reset it to 0.

                        if (self.counter >= self.framesPerSecond * self.seconds):
                                self.counter = 0

                        # Keep cycling through the walk cycle FOREVER!
                        # If our counter is an even multiple of ticksPerFrame, pick a new frame image.

                        if self.counter % self.ticksPerFrame == 0:

                                self.walkFrame = self.counter // self.ticksPerFrame
                                self.image = self.walkCycle[self.walkFrame]

                # The win directions also maintain a counter, and cycle through the win cycle on it, again
                # based on framesPerSecond, seconds and ticksPerFrame.  I think there's a
                # math error in here somewhere but as long as it works I'm not going to try and fix it.

                elif self.spriteDir == "leftWin" or self.spriteDir == "rightWin":

                        self.counter += 1

                        if self.counter < self.framesPerSecond * self.seconds:
                                if self.counter % self.ticksPerFrame == 0:

                                        self.winFrame = self.counter // self.ticksPerFrame
                                        self.image = self.winCycle[self.winFrame]                                

                        else:
                                self.counter = 0

# A Zomzie carrying a cake.  This time:  slightly less dumb.

class ZomzieCakePath(PathWalker):

        def loadFrames(self):
                
                self.rightStandLocation = 'zomzie/zom_rsadcake01.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lcake06.png')))
                self.leftStandLocation = 'zomzie/zom_lsadcake01.png'

                self.leftPoutCycle = []
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake01.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake02.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake03.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake05.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_lsadcake06.png')))
           
                self.rightWalkCycle = []     
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rcake06.png')))

                self.rightPoutCycle = []
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake01.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake02.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake03.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake05.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_rsadcake06.png')))

                self.leftWinCycle = []
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat07.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat08.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat09.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat10.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat11.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat12.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win06.png')))

                self.rightWinCycle = []
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat07.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat08.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat09.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat10.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat11.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat12.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win06.png')))

        # Simple overridable function to load up an "eh" sound and play it when we start our sad-cycle above.

        def playFrustrated(self):
                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','zomzie_eh.ogg'))
                zomEatTrack.set_volume(0.8)
                zomEatTrack.play(0)

        # The win() function actually does very little--it just figures out which direction we're facing and
        # passes the real work off to setDir, up above.

        # What it DOES do, now, is set seconds, turn off pouting and reset the counter.

        def win(self):
                
                self.counter = 0
                self.pouting = False
                self.seconds = 2
                self.setDir(self.spriteDir + "Win")

# Grandma

class GrandmaPath(PathWalker):

        def loadFrames(self):
                
                #self.rightStandLocation = 'zomzie/zom_rsadcake01.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_lwalk01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_lwalk02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_lwalk03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_lwalk04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_lwalk05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_lwalk06.png')))
                self.leftStandLocation = 'gram/gram_lwalk01.png'

                
                self.leftPoutCycle = []
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad01.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad02.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad03.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad05.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad06.png')))

                self.rightPoutCycle = []
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad01.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad02.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad03.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad05.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/gram','gram_sad06.png')))
                

                self.rightWalkCycle = []     
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_rwalk01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_rwalk02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_rwalk03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_rwalk04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_rwalk05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/gram','gram_rwalk06.png')))

                
                self.leftWinCycle = []
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_poof01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_poof02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_poof03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_poof04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_poof05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_poof06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat07.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat08.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat09.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat10.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat11.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_eat12.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_win01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_win02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_win03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_win04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_win05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/gram','gram_win06.png')))

        # Simple overridable function to load up an "eh" sound and play it when we start our sad-cycle above.

        def playFrustrated(self):
                #gramEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','gma_eh.ogg'))
                #gramEatTrack.set_volume(0.8)
                #gramEatTrack.play(0)
                pass

        # The win() function actually does very little--it just figures out which direction we're facing and
        # passes the real work off to setDir, up above.

        # What it DOES do, now, is set seconds, turn off pouting and reset the counter.

        def win(self):
                
                self.counter = 0
                self.pouting = False
                self.seconds = 2
                self.setDir(self.spriteDir + "Win")

# A Snuzzle.  Snuzzles are wonderful.

class SnuzzlePath(PathWalker):

        def loadFrames(self):
                
                self.rightStandLocation = 'zomzie/zom_rsadcake01.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_walk01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_walk02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_walk03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_walk04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_walk05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_walk06.png')))
                self.rightStandLocation = 'snuz/snuz_sleep01.png'

                self.leftPoutCycle = []
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum01.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum02.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum03.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum04.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum05.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum06.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum07.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum08.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum09.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum10.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum11.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum12.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum13.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum14.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum15.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum16.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum17.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum18.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum19.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum20.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum21.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum22.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum23.png')))
                self.leftPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum24.png')))
           
                self.rightWalkCycle = []     
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_sleep01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_sleep02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_sleep03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_sleep04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_sleep05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_sleep06.png')))
                self.rightStandLocation = 'snuz/snuz_sleep01.png'

                self.rightPoutCycle = []
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum01.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum02.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum03.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum05.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum06.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum07.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum06.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum05.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum04.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum03.png')))
                self.rightPoutCycle.append(pygame.image.load(os.path.join('data/snuz','snuz_tantrum02.png')))

                self.leftWinCycle = []
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_poof06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat06.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat07.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat08.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat09.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat10.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat11.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_eat12.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win01.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win02.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win03.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win04.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win05.png')))
                self.leftWinCycle.append(pygame.image.load(os.path.join('data/zomzie','zom_win06.png')))

        # Simple overridable function to load up an "eh" sound and play it when we start our pout-cycle above.

        def playFrustrated(self):
                snuzSnoreTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','snoozle_snooze.ogg'))
                snuzSnoreTrack.set_volume(0.8)
                snuzSnoreTrack.play(0)

        # The win() function actually does very little--it just figures out which direction we're facing and
        # passes the real work off to setDir, up above.

        # What it DOES do, now, is set seconds, turn off pouting and reset the counter.

        def win(self):
                
                self.counter = 0
                self.pouting = False
                self.seconds = 2
                self.setDir(self.spriteDir + "Win")

                        
####################################################
#  Lisa starts coding here
####################################################

# An alien with milk.

class Alium(HorizontalWalker):

        def loadFrames(self):
                
                self.rightStandLocation = 'bunnylou/bun_right.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop06.png')))                                         
                self.leftStandLocation = 'bunnylou/bun_left.png'

                self.leftSadCycle = []
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))
                
                self.rightWalkCycle = []
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop06.png')))

                self.rightSadCycle = []
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))

                ############### NEW####################
                self.nodCycle = []
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))
                #######################################

                self.rightWinCycle = []
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat07.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat08.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat09.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat10.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat11.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat12.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win06.png')))

        def playFrustrated(self):
                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','alium_eh.ogg'))
                zomEatTrack.set_volume(0.8)
                zomEatTrack.play(0)

        def win(self):
                if self.dirX == "right":
                        self.setDir("rightWin")
                elif self.dirX == "left":
                        self.setDir("leftWin")

# A punk rock zomzie with a fork

class Iggy(HorizontalWalker):

        def loadFrames(self):
                
                self.rightStandLocation = 'bunnylou/bun_right.png'
                
                self.leftWalkCycle = []
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop01.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop02.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop03.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop04.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop05.png')))
                self.leftWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_lhop06.png')))                                         
                self.leftStandLocation = 'bunnylou/bun_left.png'

                self.leftSadCycle = []
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.leftSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))
                
                self.rightWalkCycle = []
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop01.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop02.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop03.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop04.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop05.png')))
                self.rightWalkCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_rhop06.png')))

                self.rightSadCycle = []
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.rightSadCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))

                ############### NEW####################
                self.nodCycle = []
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad01.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad02.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad03.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad04.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad05.png')))
                self.nodCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_sad06.png')))
                #######################################

                self.rightWinCycle = []
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_poof06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat06.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat07.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat08.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat09.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat10.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat11.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_eat12.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win01.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win02.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win03.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win04.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win05.png')))
                self.rightWinCycle.append(pygame.image.load(os.path.join('data/bunnylou','bun_win06.png')))

        def playFrustrated(self):
                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','iggy_eh.ogg'))
                zomEatTrack.set_volume(0.8)
                zomEatTrack.play(0)

        def win(self):
                if self.dirX == "right":
                        self.setDir("rightWin")
                elif self.dirX == "left":
                        self.setDir("leftWin")

################################# END LISA CODE ###########################################

# I'm kind of proud of GoalManager.  You initialize it by giving it any arbitrary group of two
# sprites; allMet gets polled every cycle and tells you whether they've collided or not.
# It's also got a name so you can have lots of GoalManagers and pass their names
# back to the level object, which will actually know what to do with them.
                        
class GoalManager:

        def __init__(self, spriteGroup, name):
                self.spriteGroup = spriteGroup
                self.name = name

        def allMet(self):

                # All this absurdly long line does is check:
                #       1) Do you have more than one sprite in your group?
                #       2) If so, are they colliding?
                
                if len(self.spriteGroup.sprites()) > 1 and self.spriteGroup.sprites()[0].rect.colliderect(self.spriteGroup.sprites()[1].rect):
                        return True
                else:
                        if len(self.spriteGroup.sprites()) <= 1:
                                return False

        def getName(self):
                return self.name

# MouseManager also takes a sprite group, but this one can be of any size.
# You poll it by passing it the mouse coordinates on every mouseMove event
# and it'll tell you the name of the first sprite in the group it collides with.
# Meant to be used with HotPanels, below, which all have unique names so they
# can trigger instructions in the level.

class MouseManager:

        def __init__(self, spriteGroup):
                self.spriteGroup = spriteGroup

        def checkIntersections(self, coordList):
                self.x = coordList[0]
                self.y = coordList[1]
                for spriteElem in self.spriteGroup.sprites():
                        if spriteElem.rect.collidepoint(self.x, self.y) == True:
                                return spriteElem.getName()
                else:
                        return None

# Just a global object that plays a music loop, fades it out when asked to, and automatically skips to
# the next one and starts playing it when asked as well.

class MusicManager:

        def __init__(self):
                self.musicTrack = None
                self.loopNum = 0

        # It's called nextLoop but it also functions as a startLoop, since loopNum is initialized to 1.

        def nextLoop(self, volume):
                self.loopNum += 1
                loopString = ''
                if self.loopNum < 10:
                        loopString = '0'
                loopString += str(self.loopNum)
                self.musicTrack = pygame.mixer.Sound(os.path.join('data/audio/loops','music_loop' + loopString + '.ogg'))
                self.musicTrack.set_volume(volume)

                # -1 means play forever!  Until stopped.
                
                self.musicTrack.play(-1)

        def fadeLoop(self, time):
                self.musicTrack.fadeout(time)

        # There's no built-in fade_in function, so this approximates it in a loop.
        # Keeps bumping up the volume of a track (presumably started at 0) until it
        # hits max.

        def bumpVolume(self, increment, max):
                myVolume = self.musicTrack.get_volume()
                if myVolume < max:
                        self.musicTrack.set_volume(myVolume + increment)

        def getTrack(self):
                return self.musicTrack

# Animated Panel--a little hotter than the regular HotPanel,
# because it can load a full range of frames and get plugged into
# AnimatedSprites.walk().

class AnimatedPanel(pygame.sprite.Sprite):
        # Initializes to the inactive image.

        def __init__(self, screen, topleft, name, initialImage = None, ticksPerFrame = 2):
                pygame.sprite.Sprite.__init__(self)
                self.name = name
                if initialImage != None:
                        self.image,self.rect = load_image(initialImage)
                self.rect.topleft = topleft
                self.counter=0
                self.ticksPerFrame = ticksPerFrame
                self.loadFrames()

        def loadFrames(self):
                pass

        def update(self):
                self.counter+=1
                if self.counter == len(self.anim) * self.ticksPerFrame:
                        self.kill()
                        self.counter=0
                if self.counter % self.ticksPerFrame == 0:
                        self.image=self.anim[self.counter // self.ticksPerFrame]

# Make the bridge!

class AnimatedBridge(AnimatedPanel):

        def loadFrames(self):
                self.anim = []
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool01.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool03.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool01.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool03.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool01.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool03.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool04.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool05.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool06.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool05.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool04.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool05.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool06.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool05.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool04.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool05.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool06.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bridge','bridge_tool05.png')))

# Bell ringing
class BellRing(AnimatedPanel):
        # Initializes to the inactive image.

        def __init__(self, screen, topleft, name):
                pygame.sprite.Sprite.__init__(self)
                self.name = name
                self.image,self.rect = load_image('bell/bell_ring01.png')
                self.rect.topleft = topleft
                self.counter=0
                self.loadFrames()
                self.ticksPerFrame = 2

        def loadFrames(self):
                self.anim = []
                self.anim.append(pygame.image.load(os.path.join('data/bell','bell_ring01.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bell','bell_ring02.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bell','bell_ring03.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bell','bell_ring04.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bell','bell_ring05.png')))
                self.anim.append(pygame.image.load(os.path.join('data/bell','bell_ring06.png')))

# HotPanel is just a mask on sprite with a few other member variables and the ability to swap out
# its "on" and "off" images without anybody else needing to know whether it's on or off.
# Used for doors and stuff, obviously.

class HotPanel(pygame.sprite.Sprite):

        # Initializes to the inactive image.

        def __init__(self, screen, imageOnName, imageOffName, topleft, name):
                pygame.sprite.Sprite.__init__(self)
                self.name = name
                self.imageOff, self.rect = load_image(imageOffName)
                self.image = self.imageOff
                self.rect.topleft = topleft
                self.imageOn, temp = load_image(imageOnName)
                self.active = False

        # Traps to prevent activating something that's already active, and if not,
        # switches the image to on.

        def activate(self, screen):
                if self.active == False:
                        self.active = True
                        self.image = self.imageOn

        # Traps to prevent deactivating something that's already inactive, and if not,
        # switches the image to off.

        def deactivate(self, screen):
                if self.active == True:
                        self.active = False
                        self.image = self.imageOff

        def update(self):
                pass

        def draw(self, screen):
                screen.blit(self.image, self.topleft)

        # Again, a name lets the level know what to do with this guy.

        def getName(self):
                return self.name

# Even simpler than HotPanel!  No activating or deactivating here, just a sprite that can
# draw itself without having to be part of a group.

class ColdPanel(pygame.sprite.Sprite):

        def __init__(self, screen, imageName, topleft):
                pygame.sprite.Sprite.__init__(self)
                self.image, self.rect = load_image(imageName)
                self.rect.topleft = topleft

        def update(self):
                pass

        def draw(self, screen):
                screen.blit(self.image, self.topleft)

# SIMPLEST OF ALL:  an invisible sprite used for collision detection.

class InvisiblePanel(pygame.sprite.Sprite):

        def __init__(self, name, topleft, widthheight):
                self.name = name
                pygame.sprite.Sprite.__init__(self)
                self.rect = Rect(topleft, widthheight)

        def update(self):
                pass

        # Move!

        def relocate(self, topleft):
                self.rect.topleft = topleft

        # Go away!

        def vanish(self):
                self.rect.topleft = (-1000,-1000)

# Level is pretty much an interface; the only thing in here that does
# anything is blitBackground, which should never change, and the getter
# functions.  The actual functionality is done below in the Level1, Level2,
# etc. objects.

class Level:

        def __init__(self, screen, fps, myMusicManager):

                self.setupLevel(screen, fps, myMusicManager)

        def setupLevel(self, screen, myMusicManager):
                pass

        def walk(self, screen):
                pass

        def blitBackground(self, screen):
                screen.blit(self.backgroundImage, self.backgroundCoords)

        def tryHover(self, screen, currentRectName, previousRectName):
                pass

        def tryClick(self, currentRectName):
                pass
                
        def getClickableSprites(self):
                return self.clickableSprites

        def getWalkingSprites(self):
                return self.walkingSprites

        def getBackgroundImage(self):
                return self.backgroundImage

        def doSpriteGoal(self, goalName):
                pass

        def winAnimation(self, screen):
                pass

# It seems terribly wrong to do this as its own class but I don't have time
# to learn how to modularize in Python.

class Level1(Level):

        def setupLevel(self, screen, fps, myMusicManager):
                
                self.levelNum = 1
                self.fps = fps
                self.backgroundImage, tempRect = load_image('caketown.png')
                self.backgroundCoords = (0,0)
                self.winAnimationCounter = 0

                """ Create the sprites who are walking, or at least animating, when the level begins. """
                self.walkingSprites = pygame.sprite.OrderedUpdates()

                """ arguments: homeSide, startX, startY, dirX, leftLimit, rightLimit, framesPerSecond, xPixelsPerFrame, yPixelsPerFrame, waitTime """
                """ remember, rightLimit is tested against the RIGHT edge of the sprite! """
                self.leftBunnyLou = BunnyLou("left", 300, 175, "right", 300, 770, fps, 3, 0, 48)
                self.rightZomzie = ZomzieCake("right", 954, 200, "left", 600, 1080, fps, 3, 0, 48)
                
                """ Create the hotspots. """
                
                self.clickableSprites = pygame.sprite.OrderedUpdates()
                
                tempPanel = HotPanel(screen, 'door_hover.png', 'door.png', (297,182), "door1")
                self.clickableSprites.add(tempPanel)
                tempPanel = HotPanel(screen, 'door_hover.png', 'door.png', (965,193), "door2")
                self.clickableSprites.add(tempPanel)

                """ Create the coldspots. """

                self.staticSprites = pygame.sprite.OrderedUpdates()
                
                self.leftCakeBubble = ColdPanel(screen, 'thoughts/think_cake.png', (350,50))
                self.staticSprites.add(self.leftCakeBubble)
                self.rightMilkBubble = ColdPanel(screen, 'thoughts/think_milk.png', (1040,10))
                self.staticSprites.add(self.rightMilkBubble)

                """ Start the music. """

                self.myMusicManager = myMusicManager
                self.myMusicManager.nextLoop(0.7)

        def checkBubbles(self):
                if (self.leftBunnyLou.alive() == True and self.leftCakeBubble.alive() == True):
                        self.leftCakeBubble.kill()
                elif (self.leftBunnyLou.alive() == False and self.leftCakeBubble.alive() == False):
                        self.staticSprites.add(self.leftCakeBubble)
                if (self.rightZomzie.alive() == True and self.rightMilkBubble.alive() == True):
                        self.rightMilkBubble.kill()
                elif (self.rightZomzie.alive() == False and self.rightMilkBubble.alive() == False):
                        self.staticSprites.add(self.rightMilkBubble) 

        def walk(self, screen):
                self.walkingSprites.update()
                self.checkBubbles()
                self.walkingSprites.clear(screen,self.backgroundImage)
                self.clickableSprites.clear(screen, self.backgroundImage)
                self.staticSprites.clear(screen, self.backgroundImage)
                self.staticSprites.draw(screen)
                self.clickableSprites.draw(screen)
                self.walkingSprites.draw(screen)

        def tryHover(self, screen, currentRectName, previousRectName):
                if currentRectName != None:
                        for elem in self.clickableSprites.sprites():
                                if elem.getName() == currentRectName:
                                        elem.activate(screen)
                        
                elif currentRectName == None and previousRectName != None:
                        for elem in self.clickableSprites.sprites():
                                if elem.getName() == previousRectName:
                                        elem.deactivate(screen)
                                        
        def tryClick(self, currentRectName):
                if currentRectName == "door1":
                        zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','bling.ogg'))
                        zomEatTrack.set_volume(0.8)
                        zomEatTrack.play(0)
                        self.walkingSprites.add(self.leftBunnyLou)
                        return None
                if currentRectName == "door2":
                        zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','bling.ogg'))
                        zomEatTrack.set_volume(0.8)
                        zomEatTrack.play(0)
                        self.walkingSprites.add(self.rightZomzie)
                        return None

        def doSpriteGoal(self, goalName):
                if goalName == "test":
                        for elem in self.walkingSprites.sprites():
                                elem.win()
                                self.won = True

        def winCycle(self, screen):
                
                if self.won == True:
                        self.winAnimationCounter += 1

                        if self.winAnimationCounter == 1:
                                self.myMusicManager.fadeLoop(1000)

                                self.winTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','cake_win.ogg'))
                                self.winTrack.set_volume(0.7)
                                self.winTrack.play(0)
                                
                                self.myMusicManager.nextLoop(0)

                        if self.winAnimationCounter == 16:
                                bunEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','bunny_eat.ogg'))
                                bunEatTrack.set_volume(0.7)
                                bunEatTrack.play(0)

                        if self.winAnimationCounter == 19:
                                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','zomzie_eat.ogg'))
                                zomEatTrack.set_volume(0.8)
                                zomEatTrack.play(0)

                        if self.winAnimationCounter == 48:
                                zomYayTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','zomzie_yay.ogg'))
                                zomYayTrack.set_volume(0.7)
                                bunYayTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','bunny_yay.ogg'))
                                bunYayTrack.set_volume(0.7)
                                zomYayTrack.play(0)
                                bunYayTrack.play(0)

                        if self.winAnimationCounter > 48:
                                self.myMusicManager.bumpVolume(0.05, 0.65)

                        if self.winAnimationCounter == self.fps * 2:
                                return "advance"
                        else:
                                return None
                        
                else:
                        return None

class Level2(Level):

        """ True implementation of Level 2 """

        def setupLevel(self, screen, fps, myMusicManager):
                
                self.levelNum = 2
                self.fps = fps
                self.backgroundImage, tempRect = load_image('caketown2.png')
                self.backgroundCoords = (0,0)
                self.winAnimationCounter = 0
                self.miniOn = False
                self.myMusicManager = myMusicManager

                """ Create the sprites who are walking, or at least animating, when the level begins. """
                self.walkingSprites = pygame.sprite.OrderedUpdates()

                """ arguments: startX, startY, spriteDir, framesPerSecond, xPixelsPerFrame, yPixelsPerFrame, waitTime """
                self.leftZomzie = ZomzieCakePath(71, 220, "right", fps, 4, 0, 48)
                self.rightGram = GrandmaPath(890,125,"left",fps,0,1,48)
                self.workingBridge = AnimatedBridge(screen, (270,300), "animatedBridge", "bridge/bridge_broke.png", 4)
                self.rightSnuzzle = SnuzzlePath(995, 125, "right", fps, 0, 0, 48)
                self.walkingSprites.add(self.rightSnuzzle)

                """ Create our winner-bump sprites. """

                self.winCollision = pygame.sprite.OrderedUpdates()
                self.winCollision.add(self.leftZomzie)
                #self.winCollision.add(self.rightGram)
                
                """ Create the hotspots. """
                
                self.clickableSprites = pygame.sprite.OrderedUpdates()
                
                tempPanel = HotPanel(screen, 'door_hover.png', 'door.png', (98,200), "zomzieDoor")
                self.clickableSprites.add(tempPanel)
                tempPanel = HotPanel(screen, 'door_hover.png', 'door.png', (890,125), "grandmaDoor")
                self.clickableSprites.add(tempPanel)
                tempPanel = HotPanel(screen, 'bell/bell_click.png', 'bell/bell.png', (1050,-6), "bell")
                self.clickableSprites.add(tempPanel)
                
                self.bell = BellRing(screen, (1050, -6), "bell")
                
                self.sleepingSnuzzlePanel = HotPanel(screen, 'snuz/snuz_click.png', 'snuz/snuz_unclick.png', (995,125), "snuzzleSleeping")
                self.clickableSprites.add(self.sleepingSnuzzlePanel)

                """ Create the bumpers for our Zomzie. """

                self.invisibleSprites = pygame.sprite.OrderedUpdates()

                """     Including the group that will be used to detect whether they collide. """

                self.riverBankLeft = InvisiblePanel("riverBankLeft", (315, 360), (10, 120))
                self.invisibleSprites.add(self.riverBankLeft)
                self.zomzieAndBridgeBumper = pygame.sprite.OrderedUpdates()
                self.zomzieAndBridgeBumper.add(self.leftZomzie)
                self.zomzieAndBridgeBumper.add(self.riverBankLeft)

                tempPanel = InvisiblePanel("houseLeft", (69, 360), (1, 120))
                self.invisibleSprites.add(tempPanel)
                self.zomzieAndHouseBumper = pygame.sprite.OrderedUpdates()
                self.zomzieAndHouseBumper.add(self.leftZomzie)
                self.zomzieAndHouseBumper.add(tempPanel)

                tempPanel = InvisiblePanel("grandmasHouseRight", (1000,180), (1,200))
                self.invisibleSprites.add(tempPanel)
                self.zomzieAndGrandmasHouseBumper = pygame.sprite.OrderedUpdates()
                self.zomzieAndGrandmasHouseBumper.add(self.leftZomzie)
                self.zomzieAndGrandmasHouseBumper.add(tempPanel)                

                """ Create the bumpers for our Snuzzle AND Zomzie. """

                tempPanel = InvisiblePanel("pathBend1", (570, 0), (1, 800))
                self.invisibleSprites.add(tempPanel)
                self.zomzieAndPathBend1 = pygame.sprite.OrderedUpdates()
                self.zomzieAndPathBend1.add(self.leftZomzie)
                self.zomzieAndPathBend1.add(tempPanel)

                tempPanel = InvisiblePanel("pathBend1", (570, 0), (1, 800))
                self.snuzzleAndPathBend1 = pygame.sprite.OrderedUpdates()
                self.snuzzleAndPathBend1.add(self.rightSnuzzle)
                self.snuzzleAndPathBend1.add(tempPanel)

                tempPanel = InvisiblePanel("pathBend2", (685, 0), (1, 800))
                self.invisibleSprites.add(tempPanel)
                self.zomzieAndPathBend2 = pygame.sprite.OrderedUpdates()
                self.zomzieAndPathBend2.add(self.leftZomzie)
                self.zomzieAndPathBend2.add(tempPanel)
                self.snuzzleAndPathBend2 = pygame.sprite.OrderedUpdates()
                self.snuzzleAndPathBend2.add(self.rightSnuzzle)
                self.snuzzleAndPathBend2.add(tempPanel)

                tempPanel = InvisiblePanel("pathEndLeft", (-200, -200), (1,1000))
                self.invisibleSprites.add(tempPanel)
                self.snuzzleAndPathEnd = pygame.sprite.OrderedUpdates()
                self.snuzzleAndPathEnd.add(self.rightSnuzzle)
                self.snuzzleAndPathEnd.add(tempPanel)

                tempPanel = InvisiblePanel("grandmaBumper", (890, 350), (100, 1))
                self.invisibleSprites.add(tempPanel)
                self.grandmaBumper = pygame.sprite.OrderedUpdates()
                self.grandmaBumper.add(self.rightGram)
                self.grandmaBumper.add(tempPanel)

                """ Create the coldspots. """
                """ bridgeBroken also functions as a bumper for Snuzzle. """

                self.staticSprites = pygame.sprite.OrderedUpdates()
                self.bridgeFixed = ColdPanel(screen, 'bridge/bridge_fix.png', (270,300))
                
                self.bridgeBroken = AnimatedPanel(screen, (270,300), "bridge", "bridge/bridge_broke.png")
                self.staticSprites.add(self.bridgeBroken)
                self.snuzzleAndBridge = pygame.sprite.OrderedUpdates()
                self.snuzzleAndBridge.add(self.rightSnuzzle)
                self.snuzzleAndBridge.add(self.bridgeBroken)

        def walk(self, screen):
                self.walkingSprites.clear(screen,self.backgroundImage)
                self.clickableSprites.clear(screen, self.backgroundImage)
                self.staticSprites.clear(screen, self.backgroundImage)
                self.walkingSprites.update()
                self.staticSprites.draw(screen)
                self.clickableSprites.draw(screen)
                self.walkingSprites.draw(screen)

        def tryHover(self, screen, currentRectName, previousRectName):
                if currentRectName != previousRectName:

                        if previousRectName != None:
                                for elem in self.clickableSprites.sprites():
                                        if elem.getName() == previousRectName:
                                                elem.deactivate(screen)

                        if currentRectName != None:
                                for elem in self.clickableSprites.sprites():
                                        if elem.getName() == currentRectName:
                                                elem.activate(screen)
                                        
        def tryClick(self, currentRectName):
                if currentRectName == "zomzieDoor":
                        zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','bling.ogg'))
                        zomEatTrack.set_volume(0.8)
                        zomEatTrack.play(0)
                        self.walkingSprites.add(self.leftZomzie)
                        self.zomzieAndBridgeBumper.add(self.leftZomzie)
                        self.zomzieAndHouseBumper.add(self.leftZomzie)
                        return None
                elif currentRectName == "grandmaDoor":
                        zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','bling.ogg'))
                        zomEatTrack.set_volume(0.8)
                        zomEatTrack.play(0)
                        self.walkingSprites.add(self.rightGram)
                        self.winCollision.add(self.rightGram)
                        return None
                elif currentRectName == "snuzzleSleeping":
                        if self.rightSnuzzle.spriteDir == "right":
                                self.rightSnuzzle.stopAndPout(False, 2)
                        return None
                elif currentRectName == "bell":
                        tempTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','bell_bell.ogg'))
                        tempTrack.set_volume(0.8)
                        tempTrack.play(0)
                        self.walkingSprites.add(self.bell)
                        
                        if self.rightSnuzzle.spriteDir == "right":
                                self.sleepingSnuzzlePanel.kill()
                                self.rightSnuzzle.reverse()
                                self.rightSnuzzle.deflect(-4,0)

        def doSpriteGoal(self, goalName):
                if goalName == "zomzieMeetsGrandma":
                        for elem in self.winCollision.sprites():
                                elem.win()
                                self.won = True	
                        return True
                elif goalName == "zomzieHitsBridgeBumper":
                        if self.leftZomzie.spriteDir == "right":
                                self.leftZomzie.stopAndPout()
                        return False
                elif goalName == "zomzieHitsHouseBumper":
                        if self.leftZomzie.spriteDir == "left":
                                self.leftZomzie.vanish()
                                self.leftZomzie.remove(self.walkingSprites)
                        return False
                elif goalName == "zomzieHitsPathBend1":
                        if self.leftZomzie.spriteDir == "right":
                                self.leftZomzie.deflect(3,-2)
                        elif self.leftZomzie.spriteDir == "left":
                                self.leftZomzie.deflect(-4,0)
                        return False
                elif goalName == "zomzieHitsPathBend2":
                        if self.leftZomzie.spriteDir == "right":
                                self.leftZomzie.deflect(4,0)
                        elif self.leftZomzie.spriteDir == "left":
                                self.leftZomzie.deflect(-3,2)
                        return False
                elif goalName == "snuzzleHitsPathBend1":
                        if self.rightSnuzzle.spriteDir == "left":
                                self.rightSnuzzle.deflect(3,-2)
                        return False
                elif goalName == "snuzzleHitsPathBend2":
                        if self.rightSnuzzle.spriteDir == "left":
                                self.rightSnuzzle.deflect(-3,2)
                        return False
                elif goalName == "snuzzleHitsPathEnd":
                        self.rightSnuzzle.vanish()
                        self.rightSnuzzle.remove(self.walkingSprites)
                        return False
                elif goalName == "snuzzleHitsBridge":
                        if self.bridgeBroken.alive() == True:
                                self.miniOn = True
                                self.riverBankLeft.kill()
                                self.bridgeBroken.kill()
                                self.walkingSprites.add(self.bridgeFixed)
                        return False
                elif goalName == "grandmaHitsBumper":
                        if self.rightGram.pouting == False:
                                self.rightGram.stopAndPout(False)
                        return False
                elif goalName == "zomzieHitsGrandmasHouse":
                        if self.leftZomzie.spriteDir == "right":
                                self.leftZomzie.stopAndPout()
                        return False

        def miniCycle(self, screen):

                if self.miniOn == True:
                        self.winAnimationCounter += 1

                        if self.winAnimationCounter == 1:

                                self.walkingSprites.add(self.workingBridge)

                                self.rightSnuzzle.vanish(False)
                                self.rightSnuzzle.remove(self.walkingSprites)
                                self.rightSnuzzle.relocate(200,300)
                                self.rightSnuzzle.deflect(-4,0)
                                
                                self.myMusicManager.fadeLoop(1000)

                                self.miniTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','bridge_build.ogg'))
                                self.miniTrack.set_volume(1)
                                self.miniTrack.play(0)
                                
                                self.myMusicManager.nextLoop(0)

                        if self.winAnimationCounter > 72:

                                self.myMusicManager.bumpVolume(0.02, 0.7)

                        if self.winAnimationCounter == self.fps * 4:

                                self.workingBridge.kill()
                                self.walkingSprites.add(self.rightSnuzzle)
                                self.miniOn = False
                                self.winAnimationCounter = 0
                                return "done"
                        else:
                                return None
                else:
                        return None

        def winCycle(self, screen):
                
                if self.won == True:
                        self.winAnimationCounter += 1

                        if self.winAnimationCounter == 1:
                                self.myMusicManager.fadeLoop(1000)

                                self.winTrack = pygame.mixer.Sound(os.path.join('data/audio/effects','cake_win.ogg'))
                                self.winTrack.set_volume(0.7)
                                self.winTrack.play(0)
                                
                                self.myMusicManager.nextLoop(0)

                        if self.winAnimationCounter == 16:
                                bunEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','bunny_eat.ogg'))
                                bunEatTrack.set_volume(0.7)
                                bunEatTrack.play(0)

                        if self.winAnimationCounter == 19:
                                zomEatTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','zomzie_eat.ogg'))
                                zomEatTrack.set_volume(0.8)
                                zomEatTrack.play(0)

                        if self.winAnimationCounter == 48:
                                zomYayTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','zomzie_yay.ogg'))
                                zomYayTrack.set_volume(0.7)
                                bunYayTrack = pygame.mixer.Sound(os.path.join('data/audio/vox','bunny_yay.ogg'))
                                bunYayTrack.set_volume(0.7)
                                zomYayTrack.play(0)
                                bunYayTrack.play(0)

                        if self.winAnimationCounter > 48:
                                self.myMusicManager.bumpVolume(0.05, 0.7)

                        if self.winAnimationCounter == self.fps * 2:
                                return "advance"
                        else:
                                return None
                        
                else:
                        return None


def quitEverything():
        
        pygame.mixer.stop()
        pygame.mixer.quit()
        pygame.display.quit()
        sys.exit(0)        

def main():

        # Start up all the pygame session stuff.
        
        pygame.init()

        # Make the mouse look toony.
        
        pygame.mouse.set_cursor((32, 32), (0, 0), (0, 0, 0, 0, 0, 0, 0, 0, 31, 255, 255, 224, 31, 255, 255, 248, 31, 255, 255, 248, 31, 255, 255, 248, 31, 255, 255, 248, 31, 255, 255, 248, 31, 255, 255, 240, 31, 252, 0, 0, 31, 254, 0, 0, 31, 255, 0, 0, 31, 255, 128, 0, 31, 255, 192, 0, 31, 191, 224, 0, 31, 159, 240, 0, 31, 143, 248, 0, 31, 135, 252, 0, 31, 131, 254, 0, 31, 129, 255, 0, 31, 128, 255, 128, 31, 128, 127, 192, 31, 128, 63, 224, 31, 128, 31, 240, 31, 128, 15, 248, 31, 128, 7, 248, 31, 128, 3, 248, 31, 128, 1, 248, 15, 0, 0, 248, 0, 0, 0, 96, 0, 0, 0, 0, 0, 0, 0, 0), (0, 0, 0, 0, 127, 255, 255, 248, 127, 255, 255, 252, 127, 255, 255, 254, 127, 255, 255, 254, 127, 255, 255, 254, 127, 255, 255, 254, 127, 255, 255, 254, 127, 255, 255, 252, 127, 255, 255, 252, 127, 255, 255, 240, 127, 255, 192, 0, 127, 255, 224, 0, 127, 255, 240, 0, 127, 255, 248, 0, 127, 255, 252, 0, 127, 255, 254, 0, 127, 255, 255, 0, 127, 255, 255, 128, 127, 239, 255, 192, 127, 231, 255, 224, 127, 227, 255, 240, 127, 225, 255, 248, 127, 224, 255, 252, 127, 224, 127, 254, 127, 224, 63, 254, 127, 224, 31, 254, 127, 192, 15, 254, 127, 192, 7, 254, 63, 128, 3, 252, 15, 0, 1, 248, 0, 0, 0, 0))

        #########################################
        # EXTREMELY IMPORTANT MAGIC LINE FOR
        # TURNING ON XO FUNCTIONALITY
        #########################################
        
        #olpcgames.eventwrap.install()
        
        screen = pygame.display.set_mode((1200,825))
        pygame.display.set_caption("Welcome to Caketown!")
        
        clock = pygame.time.Clock()
        won = False
        fps = 36

        myMusicManager = MusicManager()

        myLevel = Level1(screen, fps, myMusicManager)
        currentRectName = None
        
        myMouseManager = MouseManager(myLevel.getClickableSprites())
        
        myGoalManager = GoalManager(myLevel.getWalkingSprites(), "test")
        
        myLevel.blitBackground(screen)
        
        pygame.display.flip()

        """ LEVEL 1 """

        while True:

                clock.tick(fps)
                
                myLevel.walk(screen)

                if (won == True):
                         if myLevel.winCycle(screen) == "advance":
                                 time.sleep(1)
                                 break

                for event in pygame.event.get():

                        if event.type == QUIT:
                                quitEverything()
                        
                        if event.type == KEYDOWN:
                                if event.key == K_q:                        
                                        quitEverything()
                                
                                elif event.key == K_ESCAPE:                        
                                        quitEverything()

                        if event.type == pygame.MOUSEBUTTONDOWN:
                                clickResult = myLevel.tryClick(currentRectName)
                                if clickResult == "quit":
                                        quitEverything()

                        if event.type == pygame.MOUSEMOTION:
                                previousRectName = currentRectName
                                currentRectName = myMouseManager.checkIntersections(pygame.mouse.get_pos())
                                myLevel.tryHover(screen, currentRectName, previousRectName)

                if myGoalManager.allMet() == True and won == False:
                        myLevel.doSpriteGoal(myGoalManager.getName())
                        myLevel.walk(screen)
                        
                        pygame.display.update()
                        pygame.display.flip()
                        won = True
                
                pygame.event.pump()
                pygame.display.flip()

        """ LEVEL 2 """

        reset = True

        while reset == True:

                reset = False
                breakWhile = False

                myLevel = Level2(screen, fps, myMusicManager)
                currentRectName = None
                won = False
                
                myMouseManager = MouseManager(myLevel.getClickableSprites())

                myGoalList = []
                myGoalList.append(GoalManager(myLevel.zomzieAndBridgeBumper, "zomzieHitsBridgeBumper"))
                myGoalList.append(GoalManager(myLevel.zomzieAndHouseBumper, "zomzieHitsHouseBumper"))
                myGoalList.append(GoalManager(myLevel.zomzieAndPathBend1, "zomzieHitsPathBend1"))
                myGoalList.append(GoalManager(myLevel.zomzieAndPathBend2, "zomzieHitsPathBend2"))
                myGoalList.append(GoalManager(myLevel.snuzzleAndPathBend1, "snuzzleHitsPathBend1"))
                myGoalList.append(GoalManager(myLevel.snuzzleAndPathBend2, "snuzzleHitsPathBend2"))
                myGoalList.append(GoalManager(myLevel.snuzzleAndPathEnd, "snuzzleHitsPathEnd"))
                myGoalList.append(GoalManager(myLevel.snuzzleAndBridge, "snuzzleHitsBridge"))
                myGoalList.append(GoalManager(myLevel.grandmaBumper, "grandmaHitsBumper"))
                myGoalList.append(GoalManager(myLevel.winCollision, "zomzieMeetsGrandma"))
                myGoalList.append(GoalManager(myLevel.zomzieAndGrandmasHouseBumper, "zomzieHitsGrandmasHouse"))

                myLevel.blitBackground(screen)
                
                pygame.display.flip()

                while True:

                        clock.tick(fps)
                
                        myMouseManager = MouseManager(myLevel.getClickableSprites())
                        
                        myLevel.walk(screen)

                        if (won == True):
                                 if myLevel.winCycle(screen) == "advance":
                                         time.sleep(1)
                                         break

                        for event in pygame.event.get():

                                if event.type == QUIT:
                                        quitEverything()
                                
                                if event.type == KEYDOWN:
                                        if event.key == K_q:                        
                                                quitEverything()
                                                
                                        if event.key == K_r:                        
                                                reset = True
                                                breakWhile = True
                                        
                                        elif event.key == K_ESCAPE:                        
                                                quitEverything()

                                if event.type == pygame.MOUSEBUTTONDOWN:
                                        clickResult = myLevel.tryClick(currentRectName)
                                        if clickResult == "quit":
                                                quitEverything()

                                if event.type == pygame.MOUSEMOTION:
                                        previousRectName = currentRectName
                                        currentRectName = myMouseManager.checkIntersections(pygame.mouse.get_pos())
                                        myLevel.tryHover(screen, currentRectName, previousRectName)

                        if breakWhile == True:
                                break

                        if won == False:
                                
                                myLevel.miniCycle(screen)

                                for goalElem in myGoalList:
                                        if goalElem.allMet():
                                                won = myLevel.doSpriteGoal(goalElem.getName())
                                                #myLevel.walk(screen)
                                
                                pygame.display.update()
                                #pygame.display.flip()
                        
                        pygame.event.pump()
                        pygame.display.flip()

                breakWhile = False

        while True:

                for event in pygame.event.get():

                        if event.type == QUIT:
                                quitEverything()
                        
                        if event.type == KEYDOWN:
                                if event.key == K_q:                        
                                        quitEverything()
                                
                                elif event.key == K_ESCAPE:                        
                                        quitEverything()
                
                pygame.event.pump()
                pygame.display.flip()
        
        pygame.mixer.stop()
        pygame.mixer.quit()
        pygame.display.quit()
        sys.exit(0)

if __name__=="__main__":
        main()

